.686
	
.model flat, stdcall
	
option casemap: none
	
	include \masm32\include\windows.inc
	
	MOUSEINPUT struct
		
		_dx dword ?
		dy dword ?
		mouseData dword ?
		dwFlags dword ?
		time dword ?
		dwExtraInfo dword ?
		
	MOUSEINPUT ends
	
	INPUT struct
		
		_type dword ?
		mi MOUSEINPUT <?>
		
	INPUT ends
	
	include \masm32\include\user32.inc
	
	include MKHook.inc
	
	includelib \masm32\lib\user32.lib
	
.radix 16
	
.data
	
	modhnd dword 0
	
	hook dword 0
	
	mouse_input INPUT <INPUT_MOUSE>
	
	params MKParams <>
	
	ptm_remainder Rational <>
	
	ins_down dword 0
	five_down dword 0
	del_down dword 0
	div_down dword 0
	mul_down dword 0
	sub_down dword 0
	add_down dword 0
	
	numlock_down dword 0
	
	numlock dword 0
	
	in_use dword 0
	
.code
	
gcd proc x:dword, y:dword	; if (x == 0 or y == 0) returns 0
							; else returns positive GCD of x and y
	mov eax, [x]
	mov ecx, [y]
	
	.if eax == 0
		
		add eax, ecx
		
		.if sign?
			
			neg eax
			
		.endif
		
		ret
		
	.elseif sign?
		
		neg eax
		
	.endif
	
	.if ecx == 0
		
		ret
		
	.elseif sign?
		
		neg ecx
		
	.endif
	
	.repeat
		
		xor edx, edx
		div ecx
		
		mov eax, ecx
		mov ecx, edx
		
	.until edx == 0
	
	ret
	
gcd endp
	
lcm proc uses esi edi \		; if (x == 0 or y == 0) returns 0
		 x:dword, y:dword	; else returns positive LCM of x and y
	
	mov esi, [x]
	mov edi, [y]
	
	.if esi == 0
		
		xor eax, eax
		ret
		
	.elseif sign?
		
		neg esi
		
	.endif
	
	.if edi == 0
		
		xor eax, eax
		ret
		
	.elseif sign?
		
		neg edi
		
	.endif
	
	invoke gcd, esi, edi
	
	mov ecx, eax
	
	mov eax, esi
	mul edi
	
	div ecx
	
	ret
	
lcm endp
	
reduce proc uses esi edi \		; if (denominator == 0) returns with eax=0
			r:Rational			; else returns with positive denominator in eax and numerator in edx
	
	mov esi, [r.numerator]
	mov edi, [r.denominator]
	
	.if edi == 0
		
		xor eax, eax
		ret
		
	.elseif sign?
		
		neg esi
		neg edi
		
	.endif
	
	invoke gcd, esi, edi
	
	mov ecx, eax
	
	mov eax, esi
	cdq
	idiv ecx
	mov esi, eax
	
	mov eax, edi
	div ecx
	
	mov edx, esi
	
	ret
	
reduce endp
	
addRationals proc uses esi edi \			; Expects positive denominators
				  r:Rational, s:Rational	; Returns incorrect result on overflows
	
	mov esi, [r.denominator]
	mov edi, [s.denominator]
	
	invoke lcm, esi, edi
	mov ecx, eax
	
	xor edx, edx
	div edi
	imul [s.numerator]
	
	mov edi, eax
	
	mov eax, ecx
	xor edx, edx
	div esi
	imul [r.numerator]
	
	add eax, edi
	
	push ecx
	push eax
	call reduce
	ret
	
addRationals endp
	
MKInstall proc uses ebx \
			   mkp:ptr MKParams
	
	.if [hook] != 0
		
		xor eax, eax
		ret
		
	.endif
	
	mov ebx, [mkp]
	assume ebx : ptr MKParams
	
;  ----  Set parameters  ----  ;
	
	invoke reduce, [ebx].ptm
	.if eax == 0
		ret
	.endif
	mov [params.ptm.numerator], edx
	mov [params.ptm.denominator], eax
	
	invoke reduce, [ebx].at_shift
	.if eax == 0
		ret
	.endif
	mov [params.at_shift.numerator], edx
	mov [params.at_shift.denominator], eax
	
	invoke reduce, [ebx].at_ctrl
	.if eax == 0
		ret
	.endif
	mov [params.at_ctrl.numerator], edx
	mov [params.at_ctrl.denominator], eax
	
	invoke reduce, [ebx].at_alt
	.if eax == 0
		ret
	.endif
	mov [params.at_alt.numerator], edx
	mov [params.at_alt.denominator], eax
	
	mov ecx, 6 * 4
	.repeat
		
		mov edx, [ebx + ecx].act_ins
		
		.if edx > MKA_ROTATE_WHEEL_BACKWARD
			
			xor eax, eax
			ret
			
		.endif
		
		mov [params.act_ins + ecx], edx
		
		sub ecx, 4
	.until sign?
	
;  ---- Set initial state  ----  ;
	
	mov [ptm_remainder.numerator], 0
	mov [ptm_remainder.denominator], 1
	
	invoke GetKeyState, VK_NUMLOCK
	
	.if eax & 80
		mov [numlock_down], 1
	.else
		mov [numlock_down], 0
	.endif
	
	.if eax & 1
		
		mov [numlock], 1
		
		.if [ebx].use_when_numlock_is == 0
			mov [in_use], 0
		.else
			mov [in_use], -1
		.endif
		
		invoke GetKeyState, VK_NUMPAD0
		and eax, 80
		mov [ins_down], eax
		
		invoke GetKeyState, VK_NUMPAD5
		and eax, 80
		mov [five_down], eax
		
		invoke GetKeyState, VK_DECIMAL
		and eax, 80
		mov [del_down], eax
		
	.else
		
		mov [numlock], 0
		
		.if [ebx].use_when_numlock_is == 0
			mov [in_use], -1
		.else
			mov [in_use], 0
		.endif
		
		invoke GetKeyState, VK_INSERT
		and eax, 80
		mov [ins_down], eax
		
		invoke GetKeyState, VK_CLEAR
		and eax, 80
		mov [five_down], eax
		
		invoke GetKeyState, VK_DELETE
		and eax, 80
		mov [del_down], eax
		
	.endif
	
	assume ebx : nothing
	
	invoke GetKeyState, VK_DIVIDE
	and eax, 80
	mov [div_down], eax
	
	invoke GetKeyState, VK_MULTIPLY
	and eax, 80
	mov [mul_down], eax
	
	invoke GetKeyState, VK_SUBTRACT
	and eax, 80
	mov [sub_down], eax
	
	invoke GetKeyState, VK_ADD
	and eax, 80
	mov [add_down], eax
	
;  ----  Install hook  ----  ;
	
	mov eax, offset llkbdproc
	invoke SetWindowsHookEx, WH_KEYBOARD_LL, eax, [modhnd], 0
	
	.if eax != 0
		
		mov [hook], eax
		mov eax, 1
		
	.endif
	
	ret
	
MKInstall endp
	
MKUninstall proc
	
	mov eax, [hook]
	
	.if eax != 0
		
		invoke UnhookWindowsHookEx, eax
		mov [hook], 0
		
	.endif
	
	ret
	
MKUninstall endp
	
calcdelta proc uses esi edi \
			   shift_down_override:dword
	
	mov esi, [params.ptm.numerator]
	mov edi, [params.ptm.denominator]
	
	.if [shift_down_override] != 0
		
		push edi
		push esi
		push [params.at_shift.denominator]
		push [params.at_shift.numerator]
		call addRationals
		
		mov esi, edx
		mov edi, eax
		
	.else
		
		invoke GetKeyState, VK_SHIFT
		.if eax & 80
			
			push edi
			push esi
			push [params.at_shift.denominator]
			push [params.at_shift.numerator]
			call addRationals
			
			mov esi, edx
			mov edi, eax
			
		.endif
		
	.endif
	
	invoke GetKeyState, VK_CONTROL
	.if eax & 80
		
		push edi
		push esi
		push [params.at_ctrl.denominator]
		push [params.at_ctrl.numerator]
		call addRationals
		
		mov esi, edx
		mov edi, eax
		
	.endif
	
	invoke GetKeyState, VK_MENU
	.if eax & 80
		
		push edi
		push esi
		push [params.at_alt.denominator]
		push [params.at_alt.numerator]
		call addRationals
		
		mov esi, edx
		mov edi, eax
		
	.endif
	
	push edi
	push esi
	push [ptm_remainder.denominator]
	push [ptm_remainder.numerator]
	call addRationals
	
	mov ecx, eax
	mov eax, edx
	cdq
	idiv ecx
	
	mov [ptm_remainder.numerator], edx
	mov [ptm_remainder.denominator], ecx
	
	ret
	
calcdelta endp
	
llkbdproc:
	
	.if dword ptr [esp + 4] == HC_ACTION
		
		mov ecx, [esp + 0C]
		
		mov eax, [ecx + 8]
		mov edx, [ecx]
		
		.if eax & LLKHF_EXTENDED
			
			.if edx == VK_DIVIDE
				
				.if !(eax & LLKHF_UP)
					
					mov ecx, [params.act_div]
					and ecx, [in_use]
					
					.if !zero?
						
						.if [div_down] == 0 || [params.act_div] >= MKA_ROTATE_WHEEL_FORWARD
							
							mov [div_down], 1
							jmp action_down
							
						.endif
						
						mov eax, 1
						ret 0C
						
					.else
						
						mov [div_down], 1
						
					.endif
					
				.else
					
					mov [div_down], 0
					
					mov ecx, [params.act_div]
					and ecx, [in_use]
					jnz action_up
					
				.endif
				
			.elseif edx == VK_NUMLOCK
				
				.if !(eax & LLKHF_UP)
					
					.if [numlock_down] == 0
						
						mov [numlock_down], 1
						
						xor [numlock], 1
						
						not [in_use]
						
					.endif
					
				.else
					
					mov [numlock_down], 0
					
				.endif
				
			.endif
			
		.else
			
			.if edx == VK_NUMPAD1
				
				.if [in_use] != 0
					
					.if !(eax & LLKHF_UP)
						
						invoke calcdelta, 0
						
						mov edx, eax
						neg edx
						mov [mouse_input.mi._dx], edx
						mov [mouse_input.mi.dy], eax
						jmp curkey_move
						
					.endif
					
					ret 0C
					
				.endif
				
			.elseif edx == VK_END
				
				.if [in_use] != 0
					
					.if !(eax & LLKHF_UP)
						
						invoke calcdelta, [numlock]
						
						mov edx, eax
						neg edx
						mov [mouse_input.mi._dx], edx
						mov [mouse_input.mi.dy], eax
						jmp curkey_move
						
					.endif
					
					ret 0C
					
				.endif
				
			.elseif edx == VK_NUMPAD2
				
				.if [in_use] != 0
					
					.if !(eax & LLKHF_UP)
						
						invoke calcdelta, 0
						
						mov [mouse_input.mi._dx], 0
						mov [mouse_input.mi.dy], eax
						jmp curkey_move
						
					.endif
					
					ret 0C
					
				.endif
				
			.elseif edx == VK_DOWN
				
				.if [in_use] != 0
					
					.if !(eax & LLKHF_UP)
						
						invoke calcdelta, [numlock]
						
						mov [mouse_input.mi._dx], 0
						mov [mouse_input.mi.dy], eax
						jmp curkey_move
						
					.endif
					
					ret 0C
					
				.endif
				
			.elseif edx == VK_NUMPAD3
				
				.if [in_use] != 0
					
					.if !(eax & LLKHF_UP)
						
						invoke calcdelta, 0
						
						mov [mouse_input.mi._dx], eax
						mov [mouse_input.mi.dy], eax
						jmp curkey_move
						
					.endif
					
					ret 0C
					
				.endif
				
			.elseif edx == VK_NEXT
				
				.if [in_use] != 0
					
					.if !(eax & LLKHF_UP)
						
						invoke calcdelta, [numlock]
						
						mov [mouse_input.mi._dx], eax
						mov [mouse_input.mi.dy], eax
						jmp curkey_move
						
					.endif
					
					ret 0C
					
				.endif
				
			.elseif edx == VK_NUMPAD4
				
				.if [in_use] != 0
					
					.if !(eax & LLKHF_UP)
						
						invoke calcdelta, 0
						
						neg eax
						mov [mouse_input.mi._dx], eax
						mov [mouse_input.mi.dy], 0
						jmp curkey_move
						
					.endif
					
					ret 0C
					
				.endif
				
			.elseif edx == VK_LEFT
				
				.if [in_use] != 0
					
					.if !(eax & LLKHF_UP)
						
						invoke calcdelta, [numlock]
						
						neg eax
						mov [mouse_input.mi._dx], eax
						mov [mouse_input.mi.dy], 0
						jmp curkey_move
						
					.endif
					
					ret 0C
					
				.endif
				
			.elseif edx == VK_NUMPAD6
				
				.if [in_use] != 0
					
					.if !(eax & LLKHF_UP)
						
						invoke calcdelta, 0
						
						mov [mouse_input.mi._dx], eax
						mov [mouse_input.mi.dy], 0
						jmp curkey_move
						
					.endif
					
					ret 0C
					
				.endif
				
			.elseif edx == VK_RIGHT
				
				.if [in_use] != 0
					
					.if !(eax & LLKHF_UP)
						
						invoke calcdelta, [numlock]
						
						mov [mouse_input.mi._dx], eax
						mov [mouse_input.mi.dy], 0
						jmp curkey_move
						
					.endif
					
					ret 0C
					
				.endif
				
			.elseif edx == VK_NUMPAD7
				
				.if [in_use] != 0
					
					.if !(eax & LLKHF_UP)
						
						invoke calcdelta, 0
						
						neg eax
						mov [mouse_input.mi._dx], eax
						mov [mouse_input.mi.dy], eax
						jmp curkey_move
						
					.endif
					
					ret 0C
					
				.endif
				
			.elseif edx == VK_HOME
				
				.if [in_use] != 0
					
					.if !(eax & LLKHF_UP)
						
						invoke calcdelta, [numlock]
						
						neg eax
						mov [mouse_input.mi._dx], eax
						mov [mouse_input.mi.dy], eax
						jmp curkey_move
						
					.endif
					
					ret 0C
					
				.endif
				
			.elseif edx == VK_NUMPAD8
				
				.if [in_use] != 0
					
					.if !(eax & LLKHF_UP)
						
						invoke calcdelta, 0
						
						neg eax
						mov [mouse_input.mi._dx], 0
						mov [mouse_input.mi.dy], eax
						jmp curkey_move
						
					.endif
					
					ret 0C
					
				.endif
				
			.elseif edx == VK_UP
				
				.if [in_use] != 0
					
					.if !(eax & LLKHF_UP)
						
						invoke calcdelta, [numlock]
						
						neg eax
						mov [mouse_input.mi._dx], 0
						mov [mouse_input.mi.dy], eax
						jmp curkey_move
						
					.endif
					
					ret 0C
					
				.endif
				
			.elseif edx == VK_NUMPAD9
				
				.if [in_use] != 0
					
					.if !(eax & LLKHF_UP)
						
						invoke calcdelta, 0
						
						mov edx, eax
						neg edx
						mov [mouse_input.mi._dx], eax
						mov [mouse_input.mi.dy], edx
						jmp curkey_move
						
					.endif
					
					ret 0C
					
				.endif
				
			.elseif edx == VK_PRIOR
				
				.if [in_use] != 0
					
					.if !(eax & LLKHF_UP)
						
						invoke calcdelta, [numlock]
						
						mov edx, eax
						neg edx
						mov [mouse_input.mi._dx], eax
						mov [mouse_input.mi.dy], edx
						jmp curkey_move
						
					.endif
					
					ret 0C
					
				.endif
				
			.elseif edx == VK_NUMPAD0 || edx == VK_INSERT
				
				.if !(eax & LLKHF_UP)
					
					mov ecx, [params.act_ins]
					and ecx, [in_use]
					
					.if !zero?
						
						.if [ins_down] == 0 || [params.act_ins] >= MKA_ROTATE_WHEEL_FORWARD
							
							mov [ins_down], 1
							jmp action_down
							
						.endif
						
						mov eax, 1
						ret 0C
						
					.else
						
						mov [ins_down], 1
						
					.endif
					
				.else
					
					mov [ins_down], 0
					
					mov ecx, [params.act_ins]
					and ecx, [in_use]
					jnz action_up
					
				.endif
				
			.elseif edx == VK_DECIMAL || edx == VK_DELETE
				
				.if !(eax & LLKHF_UP)
					
					mov ecx, [params.act_del]
					and ecx, [in_use]
					
					.if !zero?
						
						.if [del_down] == 0 || [params.act_del] >= MKA_ROTATE_WHEEL_FORWARD
							
							mov [del_down], 1
							jmp action_down
							
						.endif
						
						mov eax, 1
						ret 0C
						
					.else
						
						mov [del_down], 1
						
					.endif
					
				.else
					
					mov [del_down], 0
					
					mov ecx, [params.act_del]
					and ecx, [in_use]
					jnz action_up
					
				.endif
				
			.elseif edx == VK_NUMPAD5 || edx == VK_CLEAR
				
				.if !(eax & LLKHF_UP)
					
					mov ecx, [params.act_five]
					and ecx, [in_use]
					
					.if !zero?
						
						.if [five_down] == 0 || [params.act_five] >= MKA_ROTATE_WHEEL_FORWARD
							
							mov [five_down], 1
							jmp action_down
							
						.endif
						
						mov eax, 1
						ret 0C
						
					.else
						
						mov [five_down], 1
						
					.endif
					
				.else
					
					mov [five_down], 0
					
					mov ecx, [params.act_five]
					and ecx, [in_use]
					jnz action_up
					
				.endif
				
			.elseif edx == VK_MULTIPLY
				
				.if !(eax & LLKHF_UP)
					
					mov ecx, [params.act_mul]
					and ecx, [in_use]
					
					.if !zero?
						
						.if [mul_down] == 0 || [params.act_mul] >= MKA_ROTATE_WHEEL_FORWARD
							
							mov [mul_down], 1
							jmp action_down
							
						.endif
						
						mov eax, 1
						ret 0C
						
					.else
						
						mov [mul_down], 1
						
					.endif
					
				.else
					
					mov [mul_down], 0
					
					mov ecx, [params.act_mul]
					and ecx, [in_use]
					jnz action_up
					
				.endif
				
			.elseif edx == VK_SUBTRACT
				
				.if !(eax & LLKHF_UP)
					
					mov ecx, [params.act_sub]
					and ecx, [in_use]
					
					.if !zero?
						
						.if [sub_down] == 0 || [params.act_sub] >= MKA_ROTATE_WHEEL_FORWARD
							
							mov [sub_down], 1
							jmp action_down
							
						.endif
						
						mov eax, 1
						ret 0C
						
					.else
						
						mov [sub_down], 1
						
					.endif
					
				.else
					
					mov [sub_down], 0
					
					mov ecx, [params.act_sub]
					and ecx, [in_use]
					jnz action_up
					
				.endif
				
			.elseif edx == VK_ADD
				
				.if !(eax & LLKHF_UP)
					
					mov ecx, [params.act_add]
					and ecx, [in_use]
					
					.if !zero?
						
						.if [add_down] == 0 || [params.act_add] >= MKA_ROTATE_WHEEL_FORWARD
							
							mov [add_down], 1
							jmp action_down
							
						.endif
						
						mov eax, 1
						ret 0C
						
					.else
						
						mov [add_down], 1
						
					.endif
					
				.else
					
					mov [add_down], 0
					
					mov ecx, [params.act_add]
					and ecx, [in_use]
					jnz action_up
					
				.endif
				
			.endif
			
		.endif
		
	.endif
	
	push [esp]
	jmp CallNextHookEx
	
curkey_move:
	
	mov [mouse_input.mi.dwFlags], MOUSEEVENTF_MOVE
	mov [mouse_input.mi.mouseData], 0
	
	invoke SendInput, 1, addr mouse_input, sizeof INPUT
	ret 0C
	
action_down:
	
	xor eax, eax
	mov [mouse_input.mi._dx], eax
	mov [mouse_input.mi.dy], eax
	mov [mouse_input.mi.mouseData], eax
	
	.if ecx == MKA_EMULATE_LEFT_BUTTON || ecx == MKA_CLICKHOLD_LEFT_BUTTON
		
		mov [mouse_input.mi.dwFlags], MOUSEEVENTF_LEFTDOWN
		
	.elseif ecx == MKA_EMULATE_RIGHT_BUTTON || ecx == MKA_CLICKHOLD_RIGHT_BUTTON
		
		mov [mouse_input.mi.dwFlags], MOUSEEVENTF_RIGHTDOWN
		
	.elseif ecx == MKA_EMULATE_MIDDLE_BUTTON || ecx == MKA_CLICKHOLD_MIDDLE_BUTTON
		
		mov [mouse_input.mi.dwFlags], MOUSEEVENTF_MIDDLEDOWN
		
	.elseif ecx == MKA_RELEASE_LEFT_BUTTON
		
		mov [mouse_input.mi.dwFlags], MOUSEEVENTF_LEFTUP
		
	.elseif ecx == MKA_RELEASE_RIGHT_BUTTON
		
		mov [mouse_input.mi.dwFlags], MOUSEEVENTF_RIGHTUP
		
	.elseif ecx == MKA_RELEASE_MIDDLE_BUTTON
		
		mov [mouse_input.mi.dwFlags], MOUSEEVENTF_MIDDLEUP
		
	.elseif ecx == MKA_DBLCLICK_LEFT_BUTTON
		
		mov [mouse_input.mi.dwFlags], MOUSEEVENTF_LEFTDOWN
		invoke SendInput, 1, addr mouse_input, sizeof INPUT
		
		mov [mouse_input.mi.dwFlags], MOUSEEVENTF_LEFTUP
		invoke SendInput, 1, addr mouse_input, sizeof INPUT
		
		mov [mouse_input.mi.dwFlags], MOUSEEVENTF_LEFTDOWN
		invoke SendInput, 1, addr mouse_input, sizeof INPUT
		
		mov [mouse_input.mi.dwFlags], MOUSEEVENTF_LEFTUP
		invoke SendInput, 1, addr mouse_input, sizeof INPUT
		
		ret 0C
		
	.elseif ecx == MKA_ROTATE_WHEEL_FORWARD
		
		mov [mouse_input.mi.dwFlags], MOUSEEVENTF_WHEEL
		mov [mouse_input.mi.mouseData], WHEEL_DELTA
		
	.elseif ecx == MKA_ROTATE_WHEEL_BACKWARD
		
		mov [mouse_input.mi.dwFlags], MOUSEEVENTF_WHEEL
		mov [mouse_input.mi.mouseData], -WHEEL_DELTA
		
	.else
		
		mov eax, 1
		ret 0C
		
	.endif
	
	invoke SendInput, 1, addr mouse_input, sizeof INPUT
	ret 0C
	
action_up:
	
	xor eax, eax
	mov [mouse_input.mi._dx], eax
	mov [mouse_input.mi.dy], eax
	mov [mouse_input.mi.mouseData], eax
	
	.if ecx == MKA_EMULATE_LEFT_BUTTON
		
		mov [mouse_input.mi.dwFlags], MOUSEEVENTF_LEFTUP
		
	.elseif ecx == MKA_EMULATE_RIGHT_BUTTON
		
		mov [mouse_input.mi.dwFlags], MOUSEEVENTF_RIGHTUP
		
	.elseif ecx == MKA_EMULATE_MIDDLE_BUTTON
		
		mov [mouse_input.mi.dwFlags], MOUSEEVENTF_MIDDLEUP
		
	.else
		
		mov eax, 1
		ret 0C
		
	.endif
	
	invoke SendInput, 1, addr mouse_input, sizeof INPUT
	ret 0C
	
DllMain proc hinst:dword, reason:dword, reserved:dword
	
	.if [reason] == DLL_PROCESS_ATTACH
		
		mov edx, [hinst]
		mov [modhnd], edx
		
		mov eax, 1
		
	.endif
	
	ret
	
DllMain endp
	
end DllMain